package RiverRaid;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.Timer;

public class Tela extends JPanel implements ActionListener {

    private jogoPrincipal principal;
    private Mapa mapa;
    private Timer timer;
    public int cont;
    private boolean chave;
    private boolean pauseStart;
    public int pontos;
    private Heroi retangulos;
    private int relogio;
    public int periodo;

    public Tela(jogoPrincipal p) {

        this.pauseStart = false;
        this.retangulos = null;
        this.cont = 0;
        this.principal = p;
        this.timer = new Timer(100, this); //milesegundos,classe a ser adcionada
        this.chave = false;
        this.periodo = 4;
        this.relogio = 1;
        this.pontos = 0;



        setIgnoreRepaint(true);

        this.setBackground(Color.blue);


    }
    
    public void pauseStart(){
        
        this.pauseStart = !this.pauseStart;
        
        if(this.pauseStart == false){
            
            this.timer.start();
            
        }else{
            
            this.timer.stop();
            
        }
        
    }

    public void iniciaJogo() {
        this.chave = true;
        this.mapa = new Mapa();

        retangulos = new Heroi(this.getHeight(), this.getWidth(), this.principal);
        this.mapa.elementos.add(retangulos);
        this.mapa.vidas = 3;
        this.relogio = 1;
        this.pontos = 0;
        this.mapa.desenhar(this.getGraphics());
        this.timer.start();
        this.principal.jBsave.setEnabled(false);
        this.principal.jTFnome.setEnabled(false);


    }

    @Override
    public void paint(Graphics g) {

        super.paint(g);
        if (this.chave) {

            if (this.mapa.vidas > 0) {

                this.mapa.desenhar(g);
            } else {
                
            }

        }else{
            
            this.timer.stop();
            ImageIcon gameovericon = new ImageIcon(this.getClass().getResource("../imagens/" + "gameover.png"));
             Image gameover = gameovericon.getImage();
            g.drawImage(gameover, 0, 0, this);
            this.principal.jBsave.setEnabled(true);
            this.principal.jTFnome.setEnabled(true);
        }


        g.dispose();


    }

    private void proximaVida() {

        if (this.mapa.vidas > 0) {

            ArrayList<Elementos> eliminados = new ArrayList<Elementos>();
            retangulos = new Heroi(this.getHeight(), this.getWidth(), this.principal);
            this.mapa.elementos.add(retangulos);
            this.relogio = 1;
            
            for(Elementos q : this.mapa.elementos){
                
                if(q instanceof Inimigos){
                    
                   eliminados.add(q);
                    
                }
                
            }
            
            for(Elementos n : eliminados){
                
                this.mapa.elementos.remove(n);
                
            }
            

        } else {
            
            this.chave = false;
            
            
        }

    }

    @Override
    public void actionPerformed(ActionEvent ae) {
        String aux;

        this.principal.teclado.poll();
        
        this.mapa.periodo = this.periodo;

        if (this.mapa.vidas > 0) {
            this.mapa.enterro();

            if (this.relogio % periodo == 0) {
                this.mapa.loop();
            }
            this.relogio++;
        }

        if (this.mapa.morreu == true) {

            this.mapa.vidas--;
            this.mapa.morreu = false;
            proximaVida();


        }

        this.pontos += this.retangulos.pontos;
        aux = ("" + this.pontos);
        this.principal.jLplacar.setText(aux);


        if (pontos % 5000 == 0 && pontos != 0) {

            this.mapa.vidas++;
        }


        aux = ("" + this.mapa.vidas);
        this.principal.jLvidas.setText(aux);
        
        for(Elementos q : this.mapa.elementos){
            
            if(q instanceof Heroi){
                
                this.principal.jPBcombustivel.setValue(((Heroi) q).combustivel/5);
                this.principal.jLnc.setText("" + ((Heroi) q).combustivel);
                
            }
            
        }

        this.repaint();

    }
}
